/* 
   p      DK16.
   11.00.
  File DK16.c
*/

//--------------------------------
//   .   I2CData 
void DK16_Write ( unsigned char Quant )
{
  unsigned char i;

#ifdef CheckI2CErrors
  TicksI2C = TicksI2CMax; 
#endif
  Forever
    {
      if ( I2CStopStart () ) return;
      I2CSend ( SlaveAddrDK16 + DevAddrDK16 * 2 );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
      if ( FlagAck ) continue;
      for ( i = 0; i < Quant; i++ )
        {
          I2CSend ( I2CData [ i ] );
#ifdef CheckI2CErrors
          if ( ErrorFl ) return;
#endif
          if ( FlagAck ) break;
        }  
      if ( FlagAck ) continue;
      break;
    }   
  I2CStop ();
  DelayMS ( 2 ); 
  return;
} // DK16_Write 

//--------------------------------
//  .   I2CData
void DK16_Read ( unsigned char Addr, unsigned char Quant )
{
  unsigned char i;
  
#ifdef CheckI2CErrors
  TicksI2C = TicksI2CMax; 
#endif
  Forever
    {
      if ( I2CStopStart () ) return;
      I2CSend ( SlaveAddrDK16 + DevAddrDK16 * 2  + 1 );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
      if ( FlagAck ) continue;
      //   
      I2CSend ( Addr );
#ifdef CheckI2CErrors
      if ( ErrorFl ) return;
#endif
      if ( FlagAck ) continue;
      //   ,      
      FlagAck = 0;   
      for ( i = 0; i < Quant; i++ )
        {
          if ( i == Quant - 1 ) FlagAck = 1; //   
          I2CData [ i ] = I2CRead ();
#ifdef CheckI2CErrors
          if ( ErrorFl ) return;
#endif
        }  
      break;
    }   
  I2CStop ();
  return;
} // DK16_Read
                                                         
//--------------------------------
//    
void DK16_PutCh ( unsigned char c )
{
  I2CData [ 0 ] = 0xC0;
  I2CData [ 1 ] = c;
  DK16_Write ( 2 );
} // DK16_PutCh 

//--------------------------------
//     
void DK16_PutCd ( unsigned char c )
{
  I2CData [ 0 ] = 0x80;
  I2CData [ 1 ] = c;
  DK16_Write ( 2 );
} // DK16_PutCd 

//--------------------------------
//     
void DK16_Goto ( unsigned char pos )
{
  DK16_PutCd ( 0x80 + pos );
} // DK16_Goto 
  
//--------------------------------
//  
// ShowBlinkCursor - 2 -  , 3 -    
void DK16_InitDisp ( unsigned char ShowBlinkCursor )
{
  DelayMS ( 15 );
  DK16_PutCd ( 0x03 );
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
  DelayMS ( 5 );
  DK16_PutCd ( 0x03 );
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
  DelayMS ( 5 );
  DK16_PutCd ( 0x03 );
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
  DelayMS ( 5 );
  DK16_PutCd ( 0x02 ); // set 4 bit mode 
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
  DelayUS ( 40 );
  DK16_PutCd ( 0x28 ); // 4 bit mode, 1/16 duty, 5x8 font 
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
  DK16_PutCd ( 0x08 ); // display off 
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
  DK16_PutCd ( 0x0C + ( ShowBlinkCursor & 0x03 ) ); // display on 
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
  DK16_PutCd ( 0x06 ); // entry mode 
#ifdef CheckI2CErrors
   if ( ErrorFl ) return;
#endif
} // DK16_InitDisp

//--------------------------------
//  
void DK16_ClearDisp ()
{                     
  DK16_PutCd ( 0x01 ); 
  DelayMS ( 2 );
} // DK16_ClearDisp
 
//--------------------------------
//    
void DK16_SetKeyboardPars ( unsigned char WorkMode, unsigned char KeyAutoTime, 
  unsigned char KeyAutoSpeed, unsigned char KeyPause )
{  
  I2CData [ 0 ] = 0x01;
  I2CData [ 1 ] = WorkMode;
  I2CData [ 2 ] = KeyAutoTime;
  I2CData [ 3 ] = KeyAutoSpeed;
  I2CData [ 4 ] = KeyPause;
  DK16_Write ( 5 );
}  // DK16_SetKeyboardPars

//--------------------------------
//     
void DK16_SetKeyboardMask ( unsigned int Mask )
{  
  I2CData [ 0 ] = 0x09;
  I2CData [ 1 ] = Mask % 0x100;
  I2CData [ 2 ] = Mask / 0x100;
  DK16_Write ( 3 );  
}  // DK16_SetKeyboardMask

//--------------------------------
//   
unsigned char DK16_ReadKey ()
{                
  DK16_Read ( 0x81, 1 ); 
#ifdef CheckI2CErrors
  if ( ErrorFl ) return ( 0 );
#endif
  return ( I2CData [ 0 ] );
} // DK16_ReadKey          

//--------------------------------
//    
unsigned int DK16_ReadBitMat ()
{                
  DK16_Read ( 0x83, 2 ); 
#ifdef CheckI2CErrors
  if ( ErrorFl ) return ( 0 );
#endif
  return ( I2CData [ 0 ] + I2CData [ 1 ] * 0x100 );
} // DK16_ReadBitMat
 
