/* 
      I2C
  File I2C.c
   08.00.
*/

//--------------------------------
//   Clock  1
unsigned char I2CClockOn ()
{
  //   Clock  
  SetBit ( I2CClockD, I2CClockB );
  //  (     1)
  SetBit ( I2CClockO, I2CClockB );    
  DelayUS ( 5 ); 
  //   Clock  
  ClrBit ( I2CClockD, I2CClockB );
  //    (,  1 ) 
#ifdef CheckI2CErrors
  while ( ( ! RdBit ( I2CClockI, I2CClockB ) ) && ( TicksI2C ) ) CLRWDT ();
  if ( ! TicksI2C ) 
    { 
      ErrorFl = ErrorI2C; 
      return ( 1 ); 
    }
#else
  while ( ! RdBit ( I2CClockI, I2CClockB ) ) CLRWDT ();
#endif            
  return ( 0 );      
} // I2CClockOn
 
//--------------------------------
//   Clock  0
void I2CClockOff ()
{             
  //   Clock  
  SetBit ( I2CClockD, I2CClockB );
  //   
  ClrBit ( I2CClockO, I2CClockB );                    
  DelayUS ( 5 ); 
} // I2CClockOff
 
//--------------------------------
//    I2C -     
void I2CSend ( unsigned char Data )
{ 
  unsigned char i;
   
  for ( i = 0; i < 8; i++ )
    {
      //   Data  
      SetBit ( I2CDataD, I2CDataB );
      //  
      if ( Data & 0x80 ) SetBit ( I2CDataO, I2CDataB );
      else ClrBit ( I2CDataO, I2CDataB );
      //    
      Data = Data << 1;
      //  (     1)
      if ( I2CClockOn () ) return;
      //   
      I2CClockOff ();
    }
  // I2CData   (  ) 
  ClrBit ( I2CDataD, I2CDataB );
  //     
  if ( I2CClockOn () ) return;
  //    
  FlagAck = RdBit ( I2CDataI, I2CDataB );
  //   
  I2CClockOff ();
} // I2CSend 

//--------------------------------
//    I2C -     
unsigned char I2CRead ()
{
  unsigned char i, Data;
   
  //     
  ClrBit ( I2CDataD, I2CDataB );
  DelayUS ( 5 ); 
  for ( i = 0; i < 8; i++ )
    {
      //  (     1)
      if ( I2CClockOn () ) return ( 0 );
      Data <<= 1;   
      if ( RdBit ( I2CDataI, I2CDataB ) ) Data |= 1;
      //   
      I2CClockOff ();
      }
  // I2CData   ( ) 
  SetBit ( I2CDataD, I2CDataB );
  //    
  if ( FlagAck ) SetBit ( I2CDataO, I2CDataB );
  else ClrBit ( I2CDataO, I2CDataB );
  //     
  if ( I2CClockOn () ) return ( 0 );
  //   
  I2CClockOff ();
  return ( Data );
} // I2CRead 

//--------------------------------
//    I2C - - 
unsigned char I2CStart ()
{
  // I2CData  
  SetBit ( I2CDataD, I2CDataB );
  SetBit ( I2CDataO, I2CDataB );
  if ( I2CClockOn () ) return ( 1 );
  ClrBit ( I2CDataO, I2CDataB );
  //   
  I2CClockOff ();
  return ( 0 );
} // I2CStart 

//--------------------------------
//    I2C - - 
unsigned char I2CStop ()
{
  CLRWDT ();
#ifdef CheckI2CErrors
   ErrorFl = 0;
#endif
  // I2CData  
  SetBit ( I2CDataD, I2CDataB );
  ClrBit ( I2CDataO, I2CDataB );
  if ( I2CClockOn () ) return ( 1 );
  SetBit ( I2CDataO, I2CDataB );
  //   
  I2CClockOff ();
  return ( 0 );
} // I2CStop 

//--------------------------------
//  
unsigned char I2CStopStart ()
{                
  if ( I2CStop () ) return ( 1 );
  if ( I2CStart () ) return ( 1 );
  return ( 0 );
} // I2CStopStart
